//
//     ,ad888ba,                              88
//    d8"'    "8b
//   d8            88,dba,,adba,   ,aPP8A.A8  88     The Cmajor Toolkit
//   Y8,           88    88    88  88     88  88
//    Y8a.   .a8P  88    88    88  88,   ,88  88     (C)2024 Cmajor Software Ltd
//     '"Y888Y"'   88    88    88  '"8bbP"Y8  88     https://cmajor.dev
//                                           ,88
//                                        888P"
//
//  The Cmajor project is subject to commercial or open-source licensing.
//  You may use it under the terms of the GPLv3 (see www.gnu.org/licenses), or
//  visit https://cmajor.dev to learn about our commercial licence options.
//
//  CMAJOR IS PROVIDED "AS IS" WITHOUT ANY WARRANTY, AND ALL WARRANTIES, WHETHER
//  EXPRESSED OR IMPLIED, INCLUDING MERCHANTABILITY AND FITNESS FOR PURPOSE, ARE
//  DISCLAIMED.

#pragma once

#include "../../../modules/compiler/src/codegen/cmaj_GraphGenerator.h"

namespace cmaj::graphviz_tests
{
    static void checkSVGOutput (choc::test::TestProgress& progress)
    {
        CHOC_TEST (checkSVGOutput);

      const auto sourceDOT = R"(
        digraph
{
    rankdir=LR;
    bgcolor="#5B6A66"
    subgraph cluster_TwoGainsInSeries_0
    {
        fontname=Courier
        fontcolor=white
        label = "TwoGainsInSeries"
        color="#5B6A66"
        bgcolor="#5B6A66"
        TwoGainsInSeries_0_in[ clusterrank=local shape = none fontname=Courier label=<<TABLE BORDER = "0"><TR><TD bgcolor="#C1C7C6" PORT="in" BORDER = "1">float32<BR></BR>in</TD></TR></TABLE>> ]
        TwoGainsInSeries_0_out[ shape = none fontname=Courier label=<<TABLE BORDER = "0"><TR><TD bgcolor="#C1C7C6" PORT="out" BORDER = "1">float32<BR></BR>out</TD></TR></TABLE>> ]
        GainProcessor_1[ shape = none fontname=Courier label=<<TABLE BORDER = "0" CELLSPACING = "0"><TR><TD WIDTH="20"></TD><TD bgcolor="#C1C7C6" PORT="in" BORDER = "1" style="rounded">in</TD><TD WIDTH="10"></TD><TD WIDTH="40"></TD></TR><TR><TD BORDER = "1" colspan="100" bgcolor="#b7aab4">gain1<br/>(processor GainProcessor)</TD></TR><TR><TD WIDTH="20"></TD><TD bgcolor="#C1C7C6" PORT="out" BORDER = "1" style="rounded">out</TD><TD WIDTH="10"></TD><TD WIDTH="40"></TD></TR></TABLE>> ]
    }
    TwoGainsInSeries_0_in:in -> GainProcessor_1:in[ arrowsize=0.7 penwidth=1 ]
    GainProcessor_1:out -> TwoGainsInSeries_0_out:out[ arrowsize=0.7 penwidth=1 ]
}
)";

        const std::string svg = std::string (R"(<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
 "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
<!-- Generated by graphviz version 7.1.0 -->
<!-- Pages: 1 -->
<svg width="512pt" height="171pt"
 viewBox="0.00 0.00 512.00 170.83" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
<g id="graph0" class="graph" transform="scale(1 1) rotate(0) translate(4 166.83)")+")\""+std::string (R"(>
<polygon fill="#5b6a66" stroke="none" points="-4,4 -4,-166.83 508,-166.83 508,4 -4,4"/>
<g id="clust1" class="cluster">
<title>cluster_TwoGainsInSeries_0</title>
<polygon fill="#5b6a66" stroke="#5b6a66" points="8,-22.83 8,-154.83 496,-154.83 496,-22.83 8,-22.83"/>
<text text-anchor="middle" x="252" y="-138.23" font-family="Courier,monospace" font-size="14.00" fill="white">TwoGainsInSeries</text>
</g>
<!-- TwoGainsInSeries_0_in -->
<g id="node1" class="node">
<title>TwoGainsInSeries_0_in</title>
<polygon fill="#c1c7c6" stroke="none" points="26,-76.83 26,-115.83 90,-115.83 90,-76.83 26,-76.83"/>
<polygon fill="none" stroke="black" points="26,-76.83 26,-115.83 90,-115.83 90,-76.83 26,-76.83"/>
<text text-anchor="start" x="28.6" y="-100.23" font-family="Courier,monospace" font-size="14.00">float32</text>
<text text-anchor="start" x="49.6" y="-83.43" font-family="Courier,monospace" font-size="14.00">in</text>
</g>
<!-- GainProcessor_1 -->
<g id="node3" class="node">
<title>GainProcessor_1</title>
<path fill="#c1c7c6" stroke="none" d="M228.33,-95.83C228.33,-95.83 273.67,-95.83 273.67,-95.83 277.33,-95.83 281,-99.49 281,-103.16 281,-103.16 281,-110.49 281,-110.49 281,-114.16 277.33,-117.83 273.67,-117.83 273.67,-117.83 228.33,-117.83 228.33,-117.83 224.67,-117.83 221,-114.16 221,-110.49 221,-110.49 221,-103.16 221,-103.16 221,-99.49 224.67,-95.83 228.33,-95.83"/>
<path fill="none" stroke="black" d="M228.33,-95.83C228.33,-95.83 273.67,-95.83 273.67,-95.83 277.33,-95.83 281,-99.49 281,-103.16 281,-103.16 281,-110.49 281,-110.49 281,-114.16 277.33,-117.83 273.67,-117.83 273.67,-117.83 228.33,-117.83 228.33,-117.83 224.67,-117.83 221,-114.16 221,-110.49 221,-110.49 221,-103.16 221,-103.16 221,-99.49 224.67,-95.83 228.33,-95.83"/>
<text text-anchor="start" x="242.6" y="-102.23" font-family="Courier,monospace" font-size="14.00">in</text>
<polygon fill="#b7aab4" stroke="none" points="144,-56.83 144,-95.83 360,-95.83 360,-56.83 144,-56.83"/>
<polygon fill="none" stroke="black" points="144,-56.83 144,-95.83 360,-95.83 360,-56.83 144,-56.83"/>
<text text-anchor="start" x="231" y="-80.23" font-family="Courier,monospace" font-size="14.00">gain1</text>
<text text-anchor="start" x="146.98" y="-63.43" font-family="Courier,monospace" font-size="14.00">(processor GainProcessor)</text>
<path fill="#c1c7c6" stroke="none" d="M228.33,-34.83C228.33,-34.83 273.67,-34.83 273.67,-34.83 277.33,-34.83 281,-38.49 281,-42.16 281,-42.16 281,-49.49 281,-49.49 281,-53.16 277.33,-56.83 273.67,-56.83 273.67,-56.83 228.33,-56.83 228.33,-56.83 224.67,-56.83 221,-53.16 221,-49.49 221,-49.49 221,-42.16 221,-42.16 221,-38.49 224.67,-34.83 228.33,-34.83"/>
<path fill="none" stroke="black" d="M228.33,-34.83C228.33,-34.83 273.67,-34.83 273.67,-34.83 277.33,-34.83 281,-38.49 281,-42.16 281,-42.16 281,-49.49 281,-49.49 281,-53.16 277.33,-56.83 273.67,-56.83 273.67,-56.83 228.33,-56.83 228.33,-56.83 224.67,-56.83 221,-53.16 221,-49.49 221,-49.49 221,-42.16 221,-42.16 221,-38.49 224.67,-34.83 228.33,-34.83"/>
<text text-anchor="start" x="238.4" y="-41.23" font-family="Courier,monospace" font-size="14.00">out</text>
</g>
<!-- TwoGainsInSeries_0_in&#45;&gt;GainProcessor_1 -->
<g id="edge1" class="edge">
<title>TwoGainsInSeries_0_in:in&#45;&gt;GainProcessor_1:in</title>
<path fill="none" stroke="black" d="M89.85,-111.92C141.58,-137.34 241.1,-178.83 250.31,-127.14"/>
<polygon fill="black" stroke="black" points="252.74,-127.51 250.88,-120.34 247.86,-127.11 252.74,-127.51"/>
</g>
<!-- TwoGainsInSeries_0_out -->
<g id="node2" class="node">
<title>TwoGainsInSeries_0_out</title>
<polygon fill="#c1c7c6" stroke="none" points="414,-36.83 414,-75.83 478,-75.83 478,-36.83 414,-36.83"/>
<polygon fill="none" stroke="black" points="414,-36.83 414,-75.83 478,-75.83 478,-36.83 414,-36.83"/>
<text text-anchor="start" x="416.6" y="-60.23" font-family="Courier,monospace" font-size="14.00">float32</text>
<text text-anchor="start" x="433.4" y="-43.43" font-family="Courier,monospace" font-size="14.00">out</text>
</g>
<!-- GainProcessor_1&#45;&gt;TwoGainsInSeries_0_out -->
<g id="edge2" class="edge">
<title>GainProcessor_1:out&#45;&gt;TwoGainsInSeries_0_out:out</title>
<path fill="none" stroke="black" d="M251,-33.83C251,28.3 350.43,-9.8 406.92,-36.47"/>
<polygon fill="black" stroke="black" points="405.52,-38.51 412.89,-39.33 407.64,-34.09 405.52,-38.51"/>
</g>
</g>
</svg>
)");
        std::string output = convertDOTtoSVG (sourceDOT);
        if (svg.compare (output))
            CHOC_FAIL ("Graph SVGs do not match!");
    }

    static void checkPatchSVGOutput (choc::test::TestProgress& progress)
    {
        CHOC_TEST (checkPatchSVGOutput);

        std::string basicGain = R"(
graph TwoGainsInSeries [[ main ]]
{
    input  stream float in;
    output stream float out;

    node gain1 = GainProcessor;

    connection in -> gain1 -> out;
}

processor GainProcessor
{
    input  stream float in;
    output stream float out;

    void main()
    {
        loop
        {
            out <- in * 0.5f;
            advance();
        }
    }
}
        )";

        const std::string gainSVG = std::string (R"SVG(<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
 "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
<!-- Generated by graphviz version 7.1.0 -->
<!-- Pages: 1 -->
<svg width="577pt" height="119pt"
 viewBox="0.00 0.00 577.00 119.00" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
<g id="graph0" class="graph" transform="scale(1 1) rotate(0) translate(4 115)">
<polygon fill="#5b6a66" stroke="none" points="-4,4 -4,-115 573,-115 573,4 -4,4"/>
<g id="clust1" class="cluster">
<title>cluster_TwoGainsInSeries_0</title>
<polygon fill="#5b6a66" stroke="#5b6a66" points="8,-8 8,-103 561,-103 561,-8 8,-8"/>
<text text-anchor="middle" x="284.5" y="-86.4" font-family="Courier,monospace" font-size="14.00" fill="white">TwoGainsInSeries</text>
</g>
<!-- TwoGainsInSeries_0_in -->
<g id="node1" class="node">
<title>TwoGainsInSeries_0_in</title>
<g id="a_node1_0"><a xlink:href="javascript:openSourceFile('basicGain:4:19:');" xlink:title="&lt;TABLE&gt;">
<polygon fill="#c1c7c6" stroke="none" points="26,-24 26,-63 90,-63 90,-24 26,-24"/>
<polygon fill="none" stroke="black" points="26,-24 26,-63 90,-63 90,-24 26,-24"/>
<text text-anchor="start" x="28.6" y="-47.4" font-family="Courier,monospace" font-size="14.00">float32</text>
<text text-anchor="start" x="49.6" y="-30.6" font-family="Courier,monospace" font-size="14.00">in</text>
</a>
</g>
</g>
<!-- GainProcessor_1 -->
<g id="node3" class="node">
<title>GainProcessor_1</title>
<g id="a_node3_1"><a xlink:href="javascript:openSourceFile('basicGain:14:19:');" xlink:title="&lt;TABLE&gt;">
<path fill="#c1c7c6" stroke="none" d="M153.83,-22C153.83,-22 161.17,-22 161.17,-22 164.83,-22 168.5,-25.67 168.5,-29.33 168.5,-29.33 168.5,-56.67 168.5,-56.67 168.5,-60.33 164.83,-64 161.17,-64 161.17,-64 153.83,-64 153.83,-64 150.17,-64 146.5,-60.33 146.5,-56.67 146.5,-56.67 146.5,-29.33 146.5,-29.33 146.5,-25.67 150.17,-22 153.83,-22"/>
<path fill="none" stroke="black" d="M153.83,-22C153.83,-22 161.17,-22 161.17,-22 164.83,-22 168.5,-25.67 168.5,-29.33 168.5,-29.33 168.5,-56.67 168.5,-56.67 168.5,-60.33 164.83,-64 161.17,-64 161.17,-64 153.83,-64 153.83,-64 150.17,-64 146.5,-60.33 146.5,-56.67 146.5,-56.67 146.5,-29.33 146.5,-29.33 146.5,-25.67 150.17,-22 153.83,-22"/>
<text text-anchor="start" x="149.1" y="-38.8" font-family="Courier,monospace" font-size="14.00">in</text>
</a>
</g>
<polygon fill="#b7aab4" stroke="none" points="172.5,-22 172.5,-64 388.5,-64 388.5,-22 172.5,-22"/>
<g id="a_node3_2"><a xlink:href="javascript:openSourceFile('basicGain:7:10:');" xlink:title="&lt;TABLE&gt;">
<text text-anchor="start" x="259.5" y="-48.4" font-family="Courier,monospace" font-size="14.00">gain1</text>
</a>
</g>
<g id="a_node3_3"><a xlink:href="javascript:openSourceFile('basicGain:12:11:');" xlink:title="&lt;TABLE&gt;">
<text text-anchor="start" x="175.48" y="-28.4" font-family="Courier,monospace" font-size="14.00">(processor GainProcessor)</text>
</a>
</g>
<polygon fill="none" stroke="black" points="172.5,-22 172.5,-64 388.5,-64 388.5,-22 172.5,-22"/>
<g id="a_node3_4"><a xlink:href="javascript:openSourceFile('basicGain:15:19:');" xlink:title="&lt;TABLE&gt;">
<path fill="#c1c7c6" stroke="none" d="M402.83,-22C402.83,-22 413.17,-22 413.17,-22 418.33,-22 423.5,-27.17 423.5,-32.33 423.5,-32.33 423.5,-53.67 423.5,-53.67 423.5,-58.83 418.33,-64 413.17,-64 413.17,-64 402.83,-64 402.83,-64 397.67,-64 392.5,-58.83 392.5,-53.67 392.5,-53.67 392.5,-32.33 392.5,-32.33 392.5,-27.17 397.67,-22 402.83,-22"/>
<path fill="none" stroke="black" d="M402.83,-22C402.83,-22 413.17,-22 413.17,-22 418.33,-22 423.5,-27.17 423.5,-32.33 423.5,-32.33 423.5,-53.67 423.5,-53.67 423.5,-58.83 418.33,-64 413.17,-64 413.17,-64 402.83,-64 402.83,-64 397.67,-64 392.5,-58.83 392.5,-53.67 392.5,-53.67 392.5,-32.33 392.5,-32.33 392.5,-27.17 397.67,-22 402.83,-22"/>
<text text-anchor="start" x="395.4" y="-38.8" font-family="Courier,monospace" font-size="14.00">out</text>
</a>
</g>
</g>
<!-- TwoGainsInSeries_0_in&#45;&gt;GainProcessor_1 -->
<g id="edge1" class="edge">
<title>TwoGainsInSeries_0_in:in&#45;&gt;GainProcessor_1:in</title>
<path fill="none" stroke="black" d="M89.74,-43C106.64,-43 126.33,-43 137.2,-43"/>
<polygon fill="black" stroke="black" points="136.99,-45.45 143.99,-43 136.99,-40.55 136.99,-45.45"/>
</g>
<!-- TwoGainsInSeries_0_out -->
<g id="node2" class="node">
<title>TwoGainsInSeries_0_out</title>
<g id="a_node2_5"><a xlink:href="javascript:openSourceFile('basicGain:5:19:');" xlink:title="&lt;TABLE&gt;">
<polygon fill="#c1c7c6" stroke="none" points="479,-24 479,-63 543,-63 543,-24 479,-24"/>
<polygon fill="none" stroke="black" points="479,-24 479,-63 543,-63 543,-24 479,-24"/>
<text text-anchor="start" x="481.6" y="-47.4" font-family="Courier,monospace" font-size="14.00">float32</text>
<text text-anchor="start" x="498.4" y="-30.6" font-family="Courier,monospace" font-size="14.00">out</text>
</a>
</g>
</g>
<!-- GainProcessor_1&#45;&gt;TwoGainsInSeries_0_out -->
<g id="edge2" class="edge">
<title>GainProcessor_1:out&#45;&gt;TwoGainsInSeries_0_out:out</title>
<path fill="none" stroke="black" d="M424.5,-43C424.5,-43 448.2,-43 470.64,-43"/>
<polygon fill="black" stroke="black" points="470.62,-45.45 477.62,-43 470.62,-40.55 470.62,-45.45"/>
</g>
</g>
</svg>
)SVG");

        auto engine = cmaj::Engine::create();
        cmaj::DiagnosticMessageList messages;
        cmaj::Program program;

        if (! program.parse (messages, "basicGain", basicGain))
            CHOC_FAIL ("Failed to parse!");

        engine.setBuildSettings (cmaj::BuildSettings()
                                    .setFrequency (44100)
                                    .setSessionID (123456));

        if (! engine.load (messages, program, {}, {}))
            CHOC_FAIL ("Failed to load!");

        auto output = engine.generateCode ("graph", {});
        std::string SVGOutput = output.generatedCode;


        if (SVGOutput.empty())
            CHOC_FAIL ("Failed to Generate!");

        if (gainSVG.compare(SVGOutput))
        {
            CHOC_FAIL ("Graph SVGs do not match!");
            std::cout << SVGOutput << std::endl;
        }
    }

    void runUnitTests (choc::test::TestProgress& progress)
    {
        CHOC_CATEGORY (Graphviz);

        checkSVGOutput (progress);
        checkPatchSVGOutput (progress);
    }
}
